'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FormControl = exports.Form = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _provider = require('../provider/provider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = exports.Form = function (_React$Component) {
    _inherits(Form, _React$Component);

    function Form(props) {
        _classCallCheck(this, Form);

        var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this, props));

        _this.state = {
            ref: Math.random() * 999999999999999999 + '-' + new Date().getTime()
        };
        _this.handleSubmit = _this.handleSubmit.bind(_this);
        _this.handleReset = _this.handleReset.bind(_this);
        _this.handleFormSubmitForward = _this.handleFormSubmitForward.bind(_this);
        return _this;
    }

    _createClass(Form, [{
        key: 'handleSubmit',
        value: function handleSubmit(event) {
            var name = this.props.name;
            var ref = this.state.ref;

            event.preventDefault();
            _provider.FormEventDispatcher.dispatchSubmitForm(name, ref);
        }
    }, {
        key: 'handleReset',
        value: function handleReset(event) {
            var name = this.props.name;

            event.preventDefault();
            _provider.FormEventDispatcher.dispatchResetForm(name);
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            var name = this.props.name;

            document.addEventListener(_provider.REACT_FORMCTRL.EVENTS.FORM_SUBMITED + '#' + name, this.handleFormSubmitForward);
            _provider.FormEventDispatcher.dispatchRegisterForm(name);
        }
    }, {
        key: 'handleFormSubmitForward',
        value: function handleFormSubmitForward(event) {
            var onSubmit = this.props.onSubmit;

            if (typeof onSubmit === 'function') {
                var _event$detail = event.detail,
                    values = _event$detail.values,
                    formCtrl = _event$detail.formCtrl,
                    formRef = _event$detail.formRef;

                if (formRef == this.state.ref) {
                    onSubmit(values, formCtrl);
                }
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var name = this.props.name;

            document.removeEventListener(_provider.REACT_FORMCTRL.EVENTS.FORM_SUBMITED + '#' + name, this.handleFormSubmitForward);
            _provider.FormEventDispatcher.dispatchUnregisterForm(name);
        }
    }, {
        key: 'render',
        value: function render() {
            var handleSubmit = this.handleSubmit,
                handleReset = this.handleReset;
            var _props = this.props,
                name = _props.name,
                children = _props.children,
                className = _props.className;

            return _react2.default.createElement(
                'form',
                { id: name, name: name, className: className, onSubmit: handleSubmit, onReset: handleReset, noValidate: true },
                children
            );
        }
    }]);

    return Form;
}(_react2.default.Component);

Form.propTypes = {
    name: _propTypes2.default.string.isRequired,
    className: _propTypes2.default.string,
    onSubmit: _propTypes2.default.func
};

var FormControl = exports.FormControl = function (_React$Component2) {
    _inherits(FormControl, _React$Component2);

    function FormControl(props) {
        _classCallCheck(this, FormControl);

        var _this2 = _possibleConstructorReturn(this, (FormControl.__proto__ || Object.getPrototypeOf(FormControl)).call(this, props));

        _this2.state = {
            valid: true,
            invalid: false,
            untouched: true,
            touched: false,
            pristine: true,
            dirty: false,
            unchanged: true,
            changed: false,
            fields: {},
            values: {}
        };
        _this2.onChange = _this2.onChange.bind(_this2);
        _this2.handleFormChanged = _this2.handleFormChanged.bind(_this2);
        _this2.sync = _this2.sync.bind(_this2);
        _this2.inject = _this2.inject.bind(_this2);
        _this2.setFieldValue = _this2.setFieldValue.bind(_this2);
        return _this2;
    }

    _createClass(FormControl, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props2 = this.props,
                form = _props2.form,
                children = _props2.children;

            if (Array.isArray(children) && children.length > 1) {
                throw 'The FormControl component for "' + form + '" should have only one child, but has ' + children.length + '.';
            }
            document.addEventListener(_provider.REACT_FORMCTRL.EVENTS.FORM_CHANGED + '#' + form, this.handleFormChanged);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var form = this.props.form;

            document.removeEventListener(_provider.REACT_FORMCTRL.EVENTS.FORM_CHANGED + '#' + form, this.handleFormChanged);
        }
    }, {
        key: 'onChange',
        value: function onChange(formCtrl) {
            var onChange = this.props.onChange;

            if (typeof onChange === 'function') {
                onChange(formCtrl);
            }
        }
    }, {
        key: 'handleFormChanged',
        value: function handleFormChanged(event) {
            var payload = event.detail;
            var form = this.props.form;
            var formCtrl = payload.formCtrl;

            var syncState = this.sync(formCtrl);
            if (Object.keys(syncState).length > 0) {
                this.setState(formCtrl);
                this.onChange(formCtrl);
            }
        }
    }, {
        key: 'sync',
        value: function sync(formCtrl) {
            var syncState = {};
            if (JSON.stringify(this.state.values) !== JSON.stringify(formCtrl.values)) syncState.values = formCtrl.values;
            if (JSON.stringify(this.state.fields) !== JSON.stringify(formCtrl.fields)) syncState.fields = formCtrl.fields;
            if (this.state.valid !== formCtrl.valid) syncState.valid = formCtrl.valid;
            if (this.state.invalid !== formCtrl.invalid) syncState.invalid = formCtrl.invalid;
            if (this.state.untouched !== formCtrl.untouched) syncState.untouched = formCtrl.untouched;
            if (this.state.touched !== formCtrl.touched) syncState.touched = formCtrl.touched;
            if (this.state.pristine !== formCtrl.pristine) syncState.pristine = formCtrl.pristine;
            if (this.state.dirty !== formCtrl.dirty) syncState.dirty = formCtrl.dirty;
            if (this.state.unchanged !== formCtrl.unchanged) syncState.unchanged = formCtrl.unchanged;
            if (this.state.changed !== formCtrl.changed) syncState.changed = formCtrl.changed;
            return syncState;
        }
    }, {
        key: 'setFieldValue',
        value: function setFieldValue(fieldName, value) {
            var form = this.props.form;

            _provider.FormEventDispatcher.dispatchFieldChanged(form, fieldName, value);
        }
    }, {
        key: 'inject',
        value: function inject() {
            var _props3 = this.props,
                inject = _props3.inject,
                form = _props3.form;

            var formCtrl = _extends({}, this.state, { formName: form, setFieldValue: this.setFieldValue });
            if (typeof inject === 'function') {
                return inject(formCtrl);
            }
            return { formCtrl: formCtrl };
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            var child = children;
            if (Array.isArray(children)) {
                child = children[0];
            }
            return _react2.default.cloneElement(child, _extends({}, child.props, this.inject()));
        }
    }]);

    return FormControl;
}(_react2.default.Component);

FormControl.propTypes = {
    form: _propTypes2.default.string.isRequired,
    onChange: _propTypes2.default.func,
    inject: _propTypes2.default.func
};